### Name: som
### Title: Kohonen's self-organising maps
### Aliases: som
### Keywords: classif

### ** Examples

data(wines)
set.seed(7)

training <- sample(length(wine.classes), 120)
Xtraining <- scale(wines[training,])
som.wines <- som(Xtraining, grid = somgrid(5, 5, "hexagonal"), rlen=100)

Xtest <- scale(wines[-training,],
               center = attr(Xtraining, "scaled:center"),
               scale = attr(Xtraining, "scaled:scale"))
som.classes <- rep(0, 25)
for (i in 1:25) {
  mappedHere <- which(som.wines$classif == i)
  if (length(mappedHere) > 0) {
    classes.mappedHere <- wine.classes[training[mappedHere]]
    som.classes[i] <-
      names(table(classes.mappedHere))[table(classes.mappedHere) ==
                                       max(table(classes.mappedHere))][1]
  }
}

som.prediction <- predict(som.wines, data=Xtest)
somclass.prediction <- som.classes[som.prediction$unit.classif]
table(wine.classes[-training], somclass.prediction)



